#include "stdafx.h"
#include "CinemaProgress_probe.h"
#include "CinemaProgress_probeDlg.h"

CCinemaProgress CinemaProgress;
/*  Place this in "stdafx.h"
extern CCinemaProgress CinemaProgress;
*/

CCinemaProgress::CCinemaProgress()
{
  _enabled = FALSE;
  _mode    = CINEMAPROGRESS_TYPE_B;
  // Type B and M default data
  _size_total  = 256;
  _size_used   = 128;
  _size_window = 64;
  _position    = 0;
  // User defined draw function
  _p_user_draw_function = NULL;
}

CCinemaProgress::~CCinemaProgress()
{
}

BOOL CCinemaProgress::Enable(BOOL enable_flag)
{
  BOOL old_enabled = _enabled;

  /*
  {
    DECLARE_MODULE_NAME;
    TCHAR s[300];

    sprintf_s(s,"%s: Enable flag = %d old flag = %d\r\n",module,enable_flag,_enabled);
    ::OutputDebugString(s);
  }
  */
  _enabled = enable_flag;
  return old_enabled;
}

BOOL CCinemaProgress::IsEnabled()
{
  return _enabled;
}

void CCinemaProgress::SetParams(int size_total,int size_used,int size_window,int position)
{
  DECLARE_MODULE_NAME;
  TCHAR s[300];

  if(_mode == CINEMAPROGRESS_TYPE_USER) {
    // This function is ignored for USER type Progress Bar
    return;
  }
  //
  if(size_total < 2) {
//    sprintf_s(s," Illegal Progress Bar total size %d \n Set to default value = 256",size_total);
//    MessageBox(NULL, s, module, MB_OK|MB_APPLMODAL|MB_TOPMOST);
    sprintf_s(s,"%s: Illegal Progress Bar total size %d, set to default value = 256\r\n",module,size_total);
    UtilsR1_force_protocol_str(s);
    size_total = 256;
  }
  _size_total = size_total;
  //
  if(size_used < 1 || size_used > _size_total) {
//    sprintf_s(s," Illegal Progress Bar used size %d \n Set to default value = total size",size_used);
//    MessageBox(NULL, s, module, MB_OK|MB_APPLMODAL|MB_TOPMOST); 
    sprintf_s(s,"%s: Illegal Progress Bar used size %d, set to default value = total size\r\n",module,size_used);
    UtilsR1_force_protocol_str(s);
    size_used = _size_total;
  }
  _size_used = size_used;
  //
  if(_mode == CINEMAPROGRESS_TYPE_M) {
    if(size_window < 1 || size_window > size_total) {
//      sprintf_s(s," Illegal M-type Progress Bar window size %d \n Set to default value = used size",size_window);
//      MessageBox(NULL, s, module, MB_OK|MB_APPLMODAL|MB_TOPMOST); 
      sprintf_s(s,"%s: Illegal M-type Progress Bar window size %d, set to default value = used size\r\n",module,size_window);
      UtilsR1_force_protocol_str(s);
      size_window = _size_used;
    }
  }
  else {
    size_window = 1;
  }
  _size_window = size_window;
  //
  SetPosition(position);
}

int CCinemaProgress::SetPosition(int position)
{
  DECLARE_MODULE_NAME;
  TCHAR s[300];
  int   old_position = _position;

  if(position < 0 || position > (_size_total-_size_window)) {
    sprintf_s(s,"%s: Illegal Progress Bar position %d, set to default value = 0\r\n",module,position);
    UtilsR1_force_protocol_str(s);
    position = 0;
  }
  _position = position;
  return old_position;
}

int CCinemaProgress::GetPosition()
{
  return _position;
}

CINEMAPROGRESS_MODE CCinemaProgress::SetMode(CINEMAPROGRESS_MODE cinema_progress_mode)
{
  CINEMAPROGRESS_MODE old_mode = _mode;
  _mode = cinema_progress_mode;
  return old_mode;
}

PCINEMAPROGRESS_USER_DRAW CCinemaProgress::SetUserDraw(PCINEMAPROGRESS_USER_DRAW user_draw_function)
{
  PCINEMAPROGRESS_USER_DRAW old_user_draw_function = _p_user_draw_function;
  _p_user_draw_function = user_draw_function;
  return old_user_draw_function;
}

void CCinemaProgress::Invalidate()
{
  RECT rc;

  pMainDlg->GetDlgItem(IDC_BUTTON_CinemaProgress)->GetClientRect(&rc);
  pMainDlg->GetDlgItem(IDC_BUTTON_CinemaProgress)->InvalidateRect(&rc,FALSE);
}
