////////////////////////////////////////////////////////////////////////////
/// 
/// Cinema Progress Bar class
///
#ifndef CCinemaProgress_class
#define CCinemaProgress_class

typedef enum { CINEMAPROGRESS_TYPE_B, CINEMAPROGRESS_TYPE_M, CINEMAPROGRESS_TYPE_USER } CINEMAPROGRESS_MODE;

typedef int (*PCINEMAPROGRESS_USER_DRAW)(HDC hDC,RECT &draw_rc);

class CCinemaProgress
{
public:
  CCinemaProgress();
  virtual ~CCinemaProgress();

  virtual BOOL Enable(BOOL enable_flag);
  virtual BOOL IsEnabled();
  // Parameter "size_window" ignored for B-type Progress Bar
  virtual void SetParams(int size_all,int size_used,int size_window,int position);
  virtual int  SetPosition(int position);
  virtual int  GetPosition();

  virtual void DrawItemProgress(LPDRAWITEMSTRUCT lpDrawItemStruct);

  virtual CINEMAPROGRESS_MODE SetMode(CINEMAPROGRESS_MODE cinema_progress_mode);
  virtual PCINEMAPROGRESS_USER_DRAW SetUserDraw(PCINEMAPROGRESS_USER_DRAW user_draw_function);

  virtual void Invalidate();

protected:
  void draw_item_progress_b(HDC hDC,RECT &draw_rc);
  void draw_item_progress_m(HDC hDC,RECT &draw_rc);
  void draw_item_progress(HDC hDC,RECT &draw_rc,int marker_width);

protected:
  PCINEMAPROGRESS_USER_DRAW _p_user_draw_function;

protected:
  BOOL                _enabled;
  CINEMAPROGRESS_MODE _mode;
  // Type B and M data
  int _size_total, _size_used, _size_window, _position;
};

#endif // CCinemaProgress_class
